/************************************************************************************/
/*  Program name CAPFAEXT_ASSET_INV.sql                                             */
/*  Creater:  Karen Nip (PCCW - UniHub)                                             */
/*************   History   *************************                                */
/* 29 DEC, 2005   Karen Nip         First created                                   */
/************************************************************************************/
ALTER SESSION SET NLS_DATE_FORMAT='YYYYMMDD HH24:MI:SS';
SET SERVEROUTPUT ON SIZE 1000000;
SET VERIFY OFF

DECLARE
	lv_Prog_ID		VARCHAR2(100)	:=	'CAPFAEXT_ASSET_INV';

	lv_Scc_Count	NUMBER	:=	0;
	lv_Err_Count	NUMBER	:=	0;
	lv_Err_Msg		VARCHAR2(500)	:=	'No Error';

	lv_FileName		VARCHAR2(100)	:=	'CAPFA_ASSET_INV.dat';
	lv_PathName		VARCHAR2(100)	:=	'/tmp';
	lv_UTL_File		UTL_FILE.File_Type;

	lv_NGO_Name		VARCHAR2(100);
	lv_NGO_Count	NUMBER;

	CURSOR Cur_F(p_NGO VARCHAR2) IS
	SELECT FAI.*
	FROM   FA_ASSET_INVOICES FAI
	,      FA_ADDITIONS_B  FAB
	WHERE  FAI.ASSET_ID = FAB.ASSET_ID
	AND    SUBSTR(FAB.ASSET_NUMBER,1,4)	= p_NGO;

BEGIN
	lv_NGO_Name		:=	UPPER('&1');

	SELECT	COUNT('A')
	INTO	lv_NGO_Count
	FROM	HR_ALL_ORGANIZATION_UNITS
	WHERE	SUBSTR(Name,4,4)	=	lv_NGO_Name;

	IF	lv_NGO_Count	>=	1	THEN
		lv_UTL_File		:=	UTL_FILE.FOpen(lv_PathName, lv_FileName, 'w');
		FOR C1 IN Cur_F(lv_NGO_Name) LOOP
			UTL_FILE.PUT_LINE(
				lv_UTL_File,
				C1.ASSET_ID||CHR(9)||
				C1.PO_VENDOR_ID||CHR(9)||
				C1.ASSET_INVOICE_ID||CHR(9)||
				C1.FIXED_ASSETS_COST||CHR(9)||
				C1.DATE_EFFECTIVE||CHR(9)||
				C1.DATE_INEFFECTIVE||CHR(9)||
				C1.INVOICE_TRANSACTION_ID_IN||CHR(9)||
				C1.INVOICE_TRANSACTION_ID_OUT||CHR(9)||
				C1.DELETED_FLAG||CHR(9)||
				C1.PO_NUMBER||CHR(9)||
				C1.INVOICE_NUMBER||CHR(9)||
				C1.PAYABLES_BATCH_NAME||CHR(9)||
				C1.PAYABLES_CODE_COMBINATION_ID||CHR(9)||
				C1.FEEDER_SYSTEM_NAME||CHR(9)||
				C1.CREATE_BATCH_DATE||CHR(9)||
				C1.CREATE_BATCH_ID||CHR(9)||
				C1.INVOICE_DATE||CHR(9)||
				C1.PAYABLES_COST||CHR(9)||
				C1.POST_BATCH_ID||CHR(9)||
				C1.INVOICE_ID||CHR(9)||
				C1.AP_DISTRIBUTION_LINE_NUMBER||CHR(9)||
				C1.PAYABLES_UNITS||CHR(9)||
				C1.SPLIT_MERGED_CODE||CHR(9)||
				C1.DESCRIPTION||CHR(9)||
				C1.PARENT_MASS_ADDITION_ID||CHR(9)||
				C1.LAST_UPDATE_DATE||CHR(9)||
				C1.LAST_UPDATED_BY||CHR(9)||
				C1.CREATED_BY||CHR(9)||
				C1.CREATION_DATE||CHR(9)||
				C1.LAST_UPDATE_LOGIN||CHR(9)||
				C1.ATTRIBUTE1||CHR(9)||
				C1.ATTRIBUTE2||CHR(9)||
				C1.ATTRIBUTE3||CHR(9)||
				C1.ATTRIBUTE4||CHR(9)||
				C1.ATTRIBUTE5||CHR(9)||
				C1.ATTRIBUTE6||CHR(9)||
				C1.ATTRIBUTE7||CHR(9)||
				C1.ATTRIBUTE8||CHR(9)||
				C1.ATTRIBUTE9||CHR(9)||
				C1.ATTRIBUTE10||CHR(9)||
				C1.ATTRIBUTE11||CHR(9)||
				C1.ATTRIBUTE12||CHR(9)||
				C1.ATTRIBUTE13||CHR(9)||
				C1.ATTRIBUTE14||CHR(9)||
				C1.ATTRIBUTE15||CHR(9)||
				C1.ATTRIBUTE_CATEGORY_CODE||CHR(9)||
				C1.UNREVALUED_COST||CHR(9)||
				C1.MERGED_CODE||CHR(9)||
				C1.SPLIT_CODE||CHR(9)||
				C1.MERGE_PARENT_MASS_ADDITIONS_ID||CHR(9)||
				C1.SPLIT_PARENT_MASS_ADDITIONS_ID||CHR(9)||
				C1.PROJECT_ASSET_LINE_ID||CHR(9)||
				C1.PROJECT_ID||CHR(9)||
				C1.TASK_ID||CHR(9)||
				C1.SOURCE_LINE_ID||CHR(9)||
				CAPBREXT_COMMON.GetUser(C1.LAST_UPDATED_BY)||CHR(9)||
				CAPBREXT_COMMON.GetUser(C1.CREATED_BY)||CHR(9)||
				CAPBREXT_COMMON.GetSegment(C1.PAYABLES_CODE_COMBINATION_ID)
			);

			lv_Scc_Count	:=	lv_Scc_Count	+	1;
		END LOOP;
		UTL_FILE.FClose(lv_UTL_File);
	ELSE
		lv_Err_Count	:=	lv_Err_Count + 1;
		lv_Err_Msg		:=	lv_NGO_Name||': No such NGO exists';
	END IF;

	INSERT INTO CAPCNV_LOG(
		PROG_ID,
		PROCESS_DATE,
		RECORD_PROCESSED,
		RECORD_REJECTED,
		RECORD_EXTRACTED,
		ERR_MSG
	) VALUES (
		lv_Prog_ID,
		SYSDATE,
		lv_Scc_Count,
		lv_Err_Count,
		lv_Scc_Count-lv_Err_Count,
		lv_Err_Msg
	);

	COMMIT;
END;
/
